<!DOCTYPE html>
<html lang="en">
<head>
<meta name="viewport" content="width=device-width">
<meta charset=UTF-8 />
<title>HFS %folder%</title>
<link href="/~mystyle.css" rel="stylesheet" type="text/css">
</head>
<body>
{.$list.}
<script>var folder="%folder%"</script>
<script src="/~myscript.src"></script>
</body>
</html>

[styles]
body {background: #eef}
th {background: #47c}
tr {background: #fff}

[mystyle.css]
{.mime|text/css.}
{.add header|Cache-Control: public, max-age=86400.}
a {text-decoration: none}
td a {color:black}
a[href*=login] {float: right}
button, details {cursor: pointer; background:transparent;border:none}
tr:hover td {background: #EEE} 
td div[title] {opacity:.54; font-size:14px; display:inline-block} 
td div:nth-child(2) {width:200px} 
td div:nth-child(3) {width:100px}
td:first-child {width:72px}
td:nth-child(3) {width:72px;text-align:center}
details {display:inline-block}
header {padding-top:1.6em}
{.$styles.}

[myscript.src]
{.mime|application/javascript.}
{.add header|Cache-Control: public, max-age=86400.}
var open=0  //edit here

if(open) document.querySelector('details').setAttribute("open","")

function handleFiles(filesArray) {
var xhr = new XMLHttpRequest();
var fd = new FormData();
var progressBar = document.querySelector('progress'); progressBar.style.display=''
xhr.open("POST", folder);
for (var i=0; i<filesArray.length; i++) fd.append('myFile', filesArray[i], filesArray[i].name)
xhr.upload.onprogress = function(e) {if (e.lengthComputable) progressBar.value = e.loaded / e.total}
xhr.onload = function() {if(xhr.responseText) document.write(xhr.responseText); else location.reload()}
xhr.send(fd)
}

function del(){
var it=document.querySelectorAll('.selector:checked'), qstr=''
if(!it.length || !confirm("Delete "+it.length+" file(s) ?")) return 0;
for (var i = 0; i < it.length; i++)  {userItem=it[i]; qstr+='&selection='+userItem.value}
var xhr = new XMLHttpRequest();
xhr.open("POST", folder)
xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded")
xhr.onload = function() {document.write(xhr.responseText)}
xhr.send("action=delete"+qstr)
}

function search(){location.href=folder+"?search="+(prompt("search")||'')}

function newfold(){
var tmp=prompt("new folder")
if(tmp) location.href="/~mypage?id="+folder+tmp
}

function ren(){
var a=document.querySelector('.selector:checked').value
var b=prompt("rename to",a)
if(!b || b.match(/[\\\/\:\*\?\"\<\>\|]/)) return 0
location.href="/~myren?a="+folder+a+"&b="+folder+b
}

[myren]
{.rename|{.?a.}|{.?b.}.}
{.redirect|{.filepath|{.?a.}.}.}

[mypage]
{.mkdir|{.?id.}.}
{.redirect|{.?id.}.}

[unauthorized]
<h1>{.!Unauthorized.}</h1>
{.!Either your user name and password do not match, or you are not permitted to access this resource..}

[file]
<tr><td>
<a href="%item-url%"><img src="%item-icon%" alt="&#x1f304;" title="%item-name%" /></a></td>

[folder]
<tr><td>
<a href="%item-url%" title="%item-name%">&#x1f4c1;</a></td>

[file.jpg=file.png=file.gif]
<tr id="%item-url%" class="media"><td>
<img src="thumb/%item-url%" style="width:64px;height:64px;object-fit:cover" onclick='show("%item-url%")' alt="&#x1f304;" title="%item-name%" /></td>

[file.mp3=file.ogg=file.m3u]
<tr><td>
<button id="%item-url%" class="meda">&#x266a;</button></td>

[+file=+folder=+file.mp3=+file.ogg=+file.m3u=+file.jpg=+file.png=+file.gif]
<td>
<div><a href="%item-url%">%item-name%</a></div>
<div title="%item-comment%">%item-modified% {.if|{.get|is new.}|&#x1F195;.}</div>
<div title="%item-dl-count%">{.or|%item-size%|.}</div>
</td>
<td>
<input type="checkbox" class='selector' value="%item-url%"  ></td>
</tr>

[list]
<div id='files_outer'>
	<!-- <div style='height:1.6em;'></div>  -->

        <div>  <!-- form method='post'  -->
<header><a href="/">Home</a>{.breadcrumbs|{:<a href ="%bread-url%">%bread-name%/</a>:}.} <a href="/~login">&#x1f464; %user%</a></header>
<input type="file" id="fileElem" multiple style="display:none" onchange="handleFiles(this.files)" onclick="this.style.display=''">
<table id='files' style="width:100%; border-spacing:0px 1px; font-family:Helvetica">
<thead><tr>
<th><button onclick="search()" title="HFS %version%">&#x2315;</button>
<th><progress style="display:none"></progress> <select onchange='location=this.value'>
<option {.if|{.=|{.urlvar|sort.}|n.}|selected.} value="{.get|url|sort=n|rev={.?sort=n.}.}">{.!lv_name|{.!Name.}.}</option>
<option {.if|{.=|{.urlvar|sort.}|s.}|selected.} value="{.get|url|sort=s|rev={.?sort=s.}.}">{.!lv_size|{.!Size.}.}</option>
<option {.if|{.=|{.urlvar|sort.}|t.}|selected.} value="{.get|url|sort=t|rev={.?sort=t.}.}">{.!lv_age|{.!Timestamp.}.}</option>
<option value="{.get|url|rev={.not|{.?rev.}.}.}">order &{.if|{.?rev.}|u|d.}arr;</option>
</select>&nbsp;
{.$box panel.}
<th><button id="control"></button><button id="csty"></button>
</tr></thead>
<tbody>
%list%
</tbody>
</table>
        </div>

</div>

[box panel]
<details><summary>&#x2261;</summary>{.if|{.get|can upload.}|<button onclick="fileElem.click()">&#x21e7;</button>.}{.if|{.get|can upload.}|<button onclick="newfold()">&#x1f5c0;<sup>+</sup></button>.}{.if|{.get|can delete.}|<button onclick="del()">X</button>.}{.if|{.get|can delete.}|<button onclick="ren()">a<sup>b</sup></button>.}</details>

[not found]
<h1>{.!lv_404Error|{.!Not found.}.}</h1>
<a href="/">{.!go to root.}</a>